/*
 *	
 *	歌詞のない曲を集める
 *		Written by Kenichi Maehashi
 *	
 *	Copyright (C) 2006-2007 Kenichi Maehashi, All rights reserved.
 *	
 *	Contact:
 *		webmaster@kenichimaehashi.com
 *		http://www.KenichiMaehashi.com/
 *	
 */

var newPlaylistName = "歌詞のない曲";

doMain();

function doMain()
{
	try
	{
		var iTunesApp = WScript.CreateObject("iTunes.Application");
	}
	catch (e)
	{
		WScript.Echo("iTunes がインストールされていません。");
		return;
	}

	var iTmainLibrary = iTunesApp.LibraryPlaylist;
	var iTmainLibTracks = iTmainLibrary.Tracks;
	var numOfTracks = iTmainLibTracks.Count;
	var playlistCreated = false;
	
	for (var i = 1; i <= numOfTracks; i++)
	{
		var currentTrack = iTmainLibTracks.Item(i);
		
		try
		{
			var currentLyrics = currentTrack.Lyrics;
		}
		catch (e)
		{
			if (e.number == -2147418113)
			{
				continue;
			}
			else
			{
				WScript.Echo("エラーが発生しました。\n\n" + e.description);
			}
		}
	
		if ( (currentTrack.Location != "") && (currentLyrics != undefined) && ( currentLyrics == "") )
		{
			if (!playlistCreated)
			{
				var targetPlaylist = iTunesApp.CreatePlaylist( newPlaylistName );
				playlistCreated = true;
			}
				
			targetPlaylist.AddTrack( currentTrack );
		}
	}
	
	if (!playlistCreated)
	{
		WScript.Echo("歌詞のない曲は、見つかりませんでした。");
	}
	else
	{
		WScript.Echo("歌詞のない曲を、プレイリスト「" + newPlaylistName + "」に登録しました。");
	}
}